commit 7a7dd31d8ef504574418fca8e3bf6f037163e73b
Author: freddy77 <freddy77>
Date:   Tue Sep 29 09:16:10 2009 +0000

    fix float to money precision during conversion

diff --git a/ChangeLog b/ChangeLog
index 6472dd2..1a8461d 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Tue Sep 29 11:15:56 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/tds/convert.c: fix float to money precision during conversion
+
 Mon Sep 28 16:06:37 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/tds/login.c: Fix SSL connection under mssql2k
 
@@ -1850,4 +1853,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2872 2009/09/28 14:07:04 freddy77 Exp $
+$Id: ChangeLog,v 1.2873 2009/09/29 09:16:10 freddy77 Exp $
diff --git a/src/tds/convert.c b/src/tds/convert.c
index b665b31..0d1d44b 100644
--- a/src/tds/convert.c
+++ b/src/tds/convert.c
@@ -64,7 +64,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: convert.c,v 1.192 2009/06/12 08:53:49 freddy77 Exp $");
+TDS_RCSID(var, "$Id: convert.c,v 1.193 2009/09/29 09:16:10 freddy77 Exp $");
 
 typedef unsigned short utf16_t;
 
@@ -1428,7 +1428,7 @@ tds_convert_real(int srctype, const TDS_CHAR * src, int desttype, CONV_RESULT *
 	case SYBMONEY:
 		if (the_value > (TDS_REAL) (TDS_INT8_MAX / 10000) || the_value < (TDS_REAL) (TDS_INT8_MIN / 10000))
 			return TDS_CONVERT_OVERFLOW;
-		mymoney = ((TDS_INT8) the_value) * 10000;
+		mymoney = (TDS_INT8) (the_value * 10000);
 		cr->m.mny = mymoney;
 		return sizeof(TDS_MONEY);
 		break;
@@ -1436,7 +1436,7 @@ tds_convert_real(int srctype, const TDS_CHAR * src, int desttype, CONV_RESULT *
 	case SYBMONEY4:
 		if (the_value > (TDS_REAL) (TDS_INT_MAX / 10000) || the_value < (TDS_REAL) (TDS_INT_MIN / 10000))
 			return TDS_CONVERT_OVERFLOW;
-		mymoney4 = ((TDS_INT) the_value) * 10000;
+		mymoney4 = (TDS_INT) (the_value * 10000);
 		cr->m4.mny4 = mymoney4;
 		return sizeof(TDS_MONEY4);
 		break;
@@ -1512,14 +1512,14 @@ tds_convert_flt8(int srctype, const TDS_CHAR * src, int desttype, CONV_RESULT *
 	case SYBMONEY:
 		if (the_value > (TDS_FLOAT) (TDS_INT8_MAX / 10000) || the_value < (TDS_FLOAT) (TDS_INT8_MIN / 10000))
 			return TDS_CONVERT_OVERFLOW;
-		cr->m.mny = ((TDS_INT8) the_value) * 10000;
+		cr->m.mny = (TDS_INT8) (the_value * 10000);
 
 		return sizeof(TDS_MONEY);
 		break;
 	case SYBMONEY4:
 		if (the_value > (TDS_FLOAT) (TDS_INT_MAX / 10000) || the_value < (TDS_FLOAT) (TDS_INT_MIN / 10000))
 			return TDS_CONVERT_OVERFLOW;
-		cr->m4.mny4 = ((TDS_INT) the_value) * 10000;
+		cr->m4.mny4 = (TDS_INT) (the_value * 10000);
 		return sizeof(TDS_MONEY4);
 		break;
 	case SYBREAL:

